/**********************************************************************
 *
 * browsefilter.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: browsefilter.h 227 1999-04-06 22:22:10Z rjmcnab $
 *
 *********************************************************************/


#ifndef BROWSEFILTER_H
#define BROWSEFILTER_H


#include "gsdlconf.h"
#include "text_t.h"
#include "comtypes.h"
#include "filter.h"
#include "infodbclass.h"


class browsefilterclass : public filterclass {
protected:
  text_t gdbm_filename;
  gdbmclass *gdbmptr;

public:
  browsefilterclass ();
  virtual ~browsefilterclass ();

  // the gdbmptr remains the responsability of the calling code and
  // should be destroyed after this browsefilter is destroyed
  void set_gdbmptr (gdbmclass *thegdbmptr) {gdbmptr = thegdbmptr;}

  bool init (ostream &logout);
  text_t get_filter_name () {return "BrowseFilter";}
  void filter (const FilterRequest_t &request,
	       FilterResponse_t &response,
	       comerror_t &err, ostream &logout);
};


#endif
