/**********************************************************************
 *
 * phrasequeryfilter.cpp -- 
 * Copyright (C) 1999  DigiLib Systems Limited, New Zealand
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: phrasequeryfilter.cpp 328 1999-07-01 04:01:47Z rjmcnab $
 *
 *********************************************************************/

/*
   $Log$
   Revision 1.1  1999/07/01 04:01:47  rjmcnab
   Initial revision.


 */


#include "phrasequeryfilter.h"
#include "queryinfo.h"

#include "phrasesearch.h"

void do_nother () {
  
}


// do aditional query processing
void phrasequeryfilterclass::post_process (const queryparamclass &queryparams, const text_t &index,
					   queryresultsclass &queryresults) {
  // post-process the results if needed
  if (queryresults.orgterms.size() > 1 && !queryresults.docs.empty()) {
    // get the long version of the index
    text_t longindex;
    indexmap.to2from (index, longindex);
      
    // process each of the matched documents
    vector<docresultclass> phrasematchdocs;
    vector<docresultclass> otherdocs;
    vector<docresultclass>::iterator docs_here = queryresults.docs.begin();
    vector<docresultclass>::iterator docs_end = queryresults.docs.end();
    while (docs_here != docs_end) {
      if ((*docs_here).num_query_terms_matched == queryresults.orgterms.size() &&
	  OID_phrase_search (*mgsearchptr, *gdbmptr, queryparams.search_index,
			     longindex, queryparams.collection, queryresults.orgterms,
			     (*docs_here).docnum)) {
	(*docs_here).query_phrase_match = true;
	phrasematchdocs.push_back (*docs_here);
      } else {
	otherdocs.push_back (*docs_here);
      }
      
      docs_here++;
    }
    
    // reorder the documents if necessary
    if (!phrasematchdocs.empty()) {
      queryresults.docs = phrasematchdocs;
      queryresults.docs.insert (queryresults.docs.end(), otherdocs.begin(), otherdocs.end());
    }
  }
}
